//+------------------------------------------------------------------+
//|                                                    DigiStoch.mq4 |
//+------------------------------------------------------------------+

#property indicator_separate_window

//-------------------------------------------------------------------+

extern string font_face      = "Comic Sans MS";
extern int font_size         = 10;
extern int K_period          = 5;
extern int D_period          = 2;
extern int S_period          = 3;
extern int MAMethod		     = 0; // {0=SMA, 1=EMA, 2=SMMA, 3=LWMA}
extern bool Show_Stoch_Value = true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
//---- indicators
   IndicatorShortName("Digi Stoch");
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
  {
//----
   ObjectsDeleteAll(0,OBJ_LABEL);
   ObjectDelete("ObjLabel1"); ObjectDelete("ObjLabel2"); ObjectDelete("ObjLabel3"); ObjectDelete("ObjLabel4");
   ObjectDelete("ObjLabel5"); ObjectDelete("ObjLabel6"); ObjectDelete("ObjLabel7"); ObjectDelete("ObjLabel8");
   ObjectDelete("ObjLabel9"); ObjectDelete("ObjLabel10"); ObjectDelete("ObjLabel11"); ObjectDelete("ObjLabel12");
   ObjectDelete("ObjLabel13"); ObjectDelete("ObjLabel14"); ObjectDelete("ObjLabel15"); ObjectDelete("ObjLabel16"); 
   ObjectDelete("ObjLabel17");
   ObjectDelete("SSIG1"); ObjectDelete("SSIG2"); ObjectDelete("SSIG3"); ObjectDelete("SSIG4"); ObjectDelete("SSIG5");
   ObjectDelete("SSIG6"); ObjectDelete("SSIG7"); ObjectDelete("SSIG8"); ObjectDelete("SSIG9"); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {    
    //m1 data
    double stoch_main_m1 = iStochastic(NULL,PERIOD_M1,K_period,D_period,S_period,MAMethod,1,MODE_MAIN,0);
    double stoch_sig_m1 = iStochastic(NULL,PERIOD_M1,K_period,D_period,S_period,MAMethod,1,MODE_SIGNAL,0);

    //m5 data
    double stoch_main_m5 = iStochastic(NULL,PERIOD_M5,K_period,D_period,S_period,MAMethod,1,MODE_MAIN,0);
    double stoch_sig_m5 = iStochastic(NULL,PERIOD_M5,K_period,D_period,S_period,MAMethod,1,MODE_SIGNAL,0);

    //m15 data
    double stoch_main_m15 = iStochastic(NULL,PERIOD_M15,K_period,D_period,S_period,MAMethod,1,MODE_MAIN,0);
    double stoch_sig_m15 = iStochastic(NULL,PERIOD_M15,K_period,D_period,S_period,MAMethod,1,MODE_SIGNAL,0);
    
    //m30 data
    double stoch_main_m30 = iStochastic(NULL,PERIOD_M30,K_period,D_period,S_period,MAMethod,1,MODE_MAIN,0);
    double stoch_sig_m30 = iStochastic(NULL,PERIOD_M30,K_period,D_period,S_period,MAMethod,1,MODE_SIGNAL,0);

    //h1 data
    double stoch_main_h1 = iStochastic(NULL,PERIOD_H1,K_period,D_period,S_period,MAMethod,1,MODE_MAIN,0);
    double stoch_sig_h1 = iStochastic(NULL,PERIOD_H1,K_period,D_period,S_period,MAMethod,1,MODE_SIGNAL,0);

    //h4 data
    double stoch_main_h4 = iStochastic(NULL,PERIOD_H4,K_period,D_period,S_period,MAMethod,1,MODE_MAIN,0);
    double stoch_sig_h4 = iStochastic(NULL,PERIOD_H4,K_period,D_period,S_period,MAMethod,1,MODE_SIGNAL,0);
    
    //d1 data
    double stoch_main_d1 = iStochastic(NULL,PERIOD_D1,K_period,D_period,S_period,MAMethod,1,MODE_MAIN,0);
    double stoch_sig_d1 = iStochastic(NULL,PERIOD_D1,K_period,D_period,S_period,MAMethod,1,MODE_SIGNAL,0);
    
    //w1 data
    double stoch_main_w1 = iStochastic(NULL,PERIOD_W1,K_period,D_period,S_period,MAMethod,1,MODE_MAIN,0);
    double stoch_sig_w1 = iStochastic(NULL,PERIOD_W1,K_period,D_period,S_period,MAMethod,1,MODE_SIGNAL,0);
    
    //mn1 data
    double stoch_main_mn1 = iStochastic(NULL,PERIOD_MN1,K_period,D_period,S_period,MAMethod,1,MODE_MAIN,0);
    double stoch_sig_mn1 = iStochastic(NULL,PERIOD_MN1,K_period,D_period,S_period,MAMethod,1,MODE_SIGNAL,0);
    
    //define color
    color stoch_color_m1, stoch_color_m5, stoch_color_m15, stoch_color_m30, stoch_color_h1, stoch_color_h4, stoch_color_d1, stoch_color_w1, stoch_color_mn1;

    //define string    
    string stoch_level_m1, stoch_level_m5, stoch_level_m15, stoch_level_m30, stoch_level_h1, stoch_level_h4, stoch_level_d1, stoch_level_w1, stoch_level_mn1;
           
    if ((stoch_main_m1 >= stoch_sig_m1) && (stoch_sig_m1 < 20) && (stoch_sig_m1 != 0)) { stoch_color_m1 = Lime; }
    if ((stoch_main_m1 >= stoch_sig_m1) && (stoch_sig_m1 >= 20) && (stoch_sig_m1 <= 80)) { stoch_color_m1 = Green; }
    if ((stoch_main_m1 >= stoch_sig_m1) && (stoch_sig_m1 > 80)) { stoch_color_m1 = Green; }

    //m1 down trend
    if ((stoch_main_m1 <= stoch_sig_m1) && (stoch_sig_m1 > 80) && (stoch_sig_m1 != 100)) { stoch_color_m1 = Red; }
    if ((stoch_main_m1 <= stoch_sig_m1) && (stoch_sig_m1 >= 20) && (stoch_sig_m1 <= 80)) { stoch_color_m1 = FireBrick; }
    if ((stoch_main_m1 <= stoch_sig_m1) && (stoch_sig_m1 < 20)) { stoch_color_m1 = FireBrick; }

    //m5 up trend
    if ((stoch_main_m5 >= stoch_sig_m5) && (stoch_sig_m5 < 20) && (stoch_sig_m5 != 0)) { stoch_color_m5 = Lime; }
    if ((stoch_main_m5 >= stoch_sig_m5) && (stoch_sig_m5 >= 20) && (stoch_sig_m5 <= 80)) { stoch_color_m5 = Green; }
    if ((stoch_main_m5 >= stoch_sig_m5) && (stoch_sig_m5 > 80)) { stoch_color_m5 = Green; }

    //m5 down trend
    if ((stoch_main_m5 <= stoch_sig_m5) && (stoch_sig_m5 > 80) && (stoch_sig_m5 != 100)) { stoch_color_m5 = Red; }    
    if ((stoch_main_m5 <= stoch_sig_m5) && (stoch_sig_m5 >= 20) && (stoch_sig_m5 <= 80)) { stoch_color_m5 = FireBrick; }
    if ((stoch_main_m5 <= stoch_sig_m5) && (stoch_sig_m5 < 20)) { stoch_color_m5 = FireBrick; }

    //m15 up trend
    if ((stoch_main_m15 >= stoch_sig_m15) && (stoch_sig_m15 < 20) && (stoch_sig_m15 != 0)) { stoch_color_m15 = Lime; }
    if ((stoch_main_m15 >= stoch_sig_m15) && (stoch_sig_m15 >= 20) && (stoch_sig_m15 <= 80)) { stoch_color_m15 = Green; }
    if ((stoch_main_m15 >= stoch_sig_m15) && (stoch_sig_m15 > 80)) { stoch_color_m15 = Green; }

    //m15 down trend
    if ((stoch_main_m15 <= stoch_sig_m15) && (stoch_sig_m15 > 80) && (stoch_sig_m15 != 100)) { stoch_color_m15 = Red; }
    if ((stoch_main_m15 <= stoch_sig_m15) && (stoch_sig_m15 >= 20) && (stoch_sig_m15 <= 80)) { stoch_color_m15 = FireBrick; }
    if ((stoch_main_m15 <= stoch_sig_m15) && (stoch_sig_m15 < 20)) { stoch_color_m15 = FireBrick; }
       
    //m30 up trend
    if ((stoch_main_m30 >= stoch_sig_m30) && (stoch_sig_m30 < 20) && (stoch_sig_m30 != 0)) { stoch_color_m30 = Lime; }
    if ((stoch_main_m30 >= stoch_sig_m30) && (stoch_sig_m30 >= 20) && (stoch_sig_m30 <= 80)) { stoch_color_m30 = Green; }
    if ((stoch_main_m30 >= stoch_sig_m30) && (stoch_sig_m30 > 80)) { stoch_color_m30 = Green; }

    //m30 down trend
    if ((stoch_main_m30 <= stoch_sig_m30) && (stoch_sig_m30 > 80) && (stoch_sig_m30 != 100)) { stoch_color_m30 = Red; }
    if ((stoch_main_m30 <= stoch_sig_m30) && (stoch_sig_m30 >= 20) && (stoch_sig_m30 <= 80)) { stoch_color_m30 = FireBrick; }
    if ((stoch_main_m30 <= stoch_sig_m30) && (stoch_sig_m30 < 20)) { stoch_color_m30 = FireBrick; }

    //h1 up trend
    if ((stoch_main_h1 >= stoch_sig_h1) && (stoch_sig_h1 < 20) && (stoch_sig_h1 != 0)) { stoch_color_h1 = Lime; }
    if ((stoch_main_h1 >= stoch_sig_h1) && (stoch_sig_h1 >= 20) && (stoch_sig_h1 <= 80)) { stoch_color_h1 = Green; }
    if ((stoch_main_h1 >= stoch_sig_h1) && (stoch_sig_h1 > 80)) { stoch_color_h1 = Green; }
    
    //h1 down trend
    if ((stoch_main_h1 <= stoch_sig_h1) && (stoch_sig_h1 > 80) && (stoch_sig_h1 != 100)) { stoch_color_h1 = Red; }
    if ((stoch_main_h1 <= stoch_sig_h1) && (stoch_sig_h1 >= 20) && (stoch_sig_h1 <= 80)) { stoch_color_h1 = FireBrick; }
    if ((stoch_main_h1 <= stoch_sig_h1) && (stoch_sig_h1 < 20)) { stoch_color_h1 = FireBrick; }

    //h4 up trend
    if ((stoch_main_h4 >= stoch_sig_h4) && (stoch_sig_h4 < 20) && (stoch_sig_h4 != 0)) { stoch_color_h4 = Lime; }    
    if ((stoch_main_h4 >= stoch_sig_h4) && (stoch_sig_h4 >= 20) && (stoch_sig_h4 <= 80)) { stoch_color_h4 = Green; }
    if ((stoch_main_h4 >= stoch_sig_h4) && (stoch_sig_h4 > 80)) { stoch_color_h4 = Green; }
    
    //h4 down trend
    if ((stoch_main_h4 <= stoch_sig_h4) && (stoch_sig_h4 > 80) && (stoch_sig_h4 != 100)) { stoch_color_h4 = Red; }
    if ((stoch_main_h4 <= stoch_sig_h4) && (stoch_sig_h4 >= 20) && (stoch_sig_h4 <= 80)) { stoch_color_h4 = FireBrick; }
    if ((stoch_main_h4 <= stoch_sig_h4) && (stoch_sig_h4 < 20)) { stoch_color_h4 = FireBrick; }
    
    //d1 up trend
    if ((stoch_main_d1 >= stoch_sig_d1) && (stoch_sig_d1 < 20) && (stoch_sig_d1 != 0)) { stoch_color_d1 = Lime; }
    if ((stoch_main_d1 >= stoch_sig_d1) && (stoch_sig_d1 >= 20) && (stoch_sig_d1 <= 80)) { stoch_color_d1 = Green; }
    if ((stoch_main_d1 >= stoch_sig_d1) && (stoch_sig_d1 > 80)) { stoch_color_d1 = Green; }
    
    //d1 down trend
    if ((stoch_main_d1 <= stoch_sig_d1) && (stoch_sig_d1 > 80) && (stoch_sig_d1 != 100)) { stoch_color_d1 = Red; }
    if ((stoch_main_d1 <= stoch_sig_d1) && (stoch_sig_d1 >= 20) && (stoch_sig_d1 <= 80)) { stoch_color_d1 = FireBrick; }
    if ((stoch_main_d1 <= stoch_sig_d1) && (stoch_sig_d1 < 20)) { stoch_color_d1 = FireBrick; }
    
    //w1 up trend
    if ((stoch_main_w1 >= stoch_sig_w1) && (stoch_sig_w1 < 20) && (stoch_sig_w1 != 0)) { stoch_color_w1 = Lime; }
    if ((stoch_main_w1 >= stoch_sig_w1) && (stoch_sig_w1 >= 20) && (stoch_sig_w1 <= 80)) { stoch_color_w1 = Green; }
    if ((stoch_main_w1 >= stoch_sig_w1) && (stoch_sig_w1 > 80)) { stoch_color_w1 = Green; }
    
    //w1 down trend
    if ((stoch_main_w1 <= stoch_sig_w1) && (stoch_sig_w1 > 80) && (stoch_sig_w1 != 100)) { stoch_color_w1 = Red; }
    if ((stoch_main_w1 <= stoch_sig_w1) && (stoch_sig_w1 >= 20) && (stoch_sig_w1 <= 80)) { stoch_color_w1 = FireBrick; }
    if ((stoch_main_w1 <= stoch_sig_w1) && (stoch_sig_w1 < 20)) { stoch_color_w1 = FireBrick; }
    
    //mn1 up trend
    if ((stoch_main_mn1 >= stoch_sig_mn1) && (stoch_sig_mn1 < 20) && (stoch_sig_mn1 != 0)) { stoch_color_mn1 = Lime; }
    if ((stoch_main_mn1 >= stoch_sig_mn1) && (stoch_sig_mn1 >= 20) && (stoch_sig_mn1 <= 80)) { stoch_color_mn1 = Green; }
    if ((stoch_main_mn1 >= stoch_sig_mn1) && (stoch_sig_mn1 > 80)) { stoch_color_mn1 = Green; }
    
    //mn1 down trend
    if ((stoch_main_mn1 <= stoch_sig_mn1) && (stoch_sig_mn1 > 80) && (stoch_sig_mn1 != 100)) { stoch_color_mn1 = Red; }
    if ((stoch_main_mn1 <= stoch_sig_mn1) && (stoch_sig_mn1 >= 20) && (stoch_sig_mn1 <= 80)) { stoch_color_mn1 = FireBrick; }
    if ((stoch_main_mn1 <= stoch_sig_mn1) && (stoch_sig_mn1 < 20)) { stoch_color_mn1 = FireBrick; }
    //Show Digital Stochastic Value
    if (Show_Stoch_Value == true) 
    {
      //stochastic value
      string stoch_m1_val = stoch_sig_m1;
      string stoch_m5_val = stoch_sig_m5;
      string stoch_m15_val = stoch_sig_m15;
      string stoch_m30_val = stoch_sig_m30;
      string stoch_h1_val = stoch_sig_h1;
      string stoch_h4_val = stoch_sig_h4;
      string stoch_d1_val = stoch_sig_d1; 
      string stoch_w1_val = stoch_sig_w1; 
      string stoch_mn1_val = stoch_sig_mn1;                           
            
      //stoch m1 value
      ObjectCreate("ObjLabel9", OBJ_LABEL, WindowFind("Digi Stoch"), 0, 0);
        ObjectSetText("ObjLabel9","M1: "+StringSubstr(stoch_m1_val,0,5)+" ",font_size, font_face, stoch_color_m1);
        ObjectSet("ObjLabel9", OBJPROP_CORNER, 0);
        ObjectSet("ObjLabel9", OBJPROP_XDISTANCE, 80);
        ObjectSet("ObjLabel9", OBJPROP_YDISTANCE, 3);
        
      //stoch m5 value            
      ObjectCreate("ObjLabel11", OBJ_LABEL, WindowFind("Digi Stoch"), 0, 0);
        ObjectSetText("ObjLabel11","M5: "+StringSubstr(stoch_m5_val,0,5),font_size, font_face, stoch_color_m5);
        ObjectSet("ObjLabel11", OBJPROP_CORNER, 0);
        ObjectSet("ObjLabel11", OBJPROP_XDISTANCE, 170);
        ObjectSet("ObjLabel11", OBJPROP_YDISTANCE, 3);          
        
      //stoch m15 value        
      ObjectCreate("ObjLabel13", OBJ_LABEL, WindowFind("Digi Stoch"), 0, 0);
        ObjectSetText("ObjLabel13","M15: "+StringSubstr(stoch_m15_val,0,5),font_size, font_face, stoch_color_m15);
        ObjectSet("ObjLabel13", OBJPROP_CORNER, 0);
        ObjectSet("ObjLabel13", OBJPROP_XDISTANCE, 260);
        ObjectSet("ObjLabel13", OBJPROP_YDISTANCE, 3);        
        
      //stoch m30 value
      ObjectCreate("ObjLabel10", OBJ_LABEL, WindowFind("Digi Stoch"), 0, 0);
        ObjectSetText("ObjLabel10","M30: "+StringSubstr(stoch_m30_val,0,5),font_size, font_face, stoch_color_m30);
        ObjectSet("ObjLabel10", OBJPROP_CORNER, 0);
        ObjectSet("ObjLabel10", OBJPROP_XDISTANCE, 360);
        ObjectSet("ObjLabel10", OBJPROP_YDISTANCE, 3);
    
      //stoch h1 value
      ObjectCreate("ObjLabel12", OBJ_LABEL, WindowFind("Digi Stoch"), 0, 0);
        ObjectSetText("ObjLabel12","H1: "+StringSubstr(stoch_h1_val,0,5),font_size, font_face, stoch_color_h1);
        ObjectSet("ObjLabel12", OBJPROP_CORNER, 0);
        ObjectSet("ObjLabel12", OBJPROP_XDISTANCE, 460);
        ObjectSet("ObjLabel12", OBJPROP_YDISTANCE, 3);       
     
      //stoch h4 value
      ObjectCreate("ObjLabel14", OBJ_LABEL, WindowFind("Digi Stoch"), 0, 0);
        ObjectSetText("ObjLabel14","H4: "+StringSubstr(stoch_h4_val,0,5),font_size, font_face, stoch_color_h4);
        ObjectSet("ObjLabel14", OBJPROP_CORNER, 0);
        ObjectSet("ObjLabel14", OBJPROP_XDISTANCE, 550);
        ObjectSet("ObjLabel14", OBJPROP_YDISTANCE, 3);        
               
      //stoch d1 value
      ObjectCreate("ObjLabel15", OBJ_LABEL, WindowFind("Digi Stoch"), 0, 0);
        ObjectSetText("ObjLabel15","D1: "+StringSubstr(stoch_d1_val,0,5),font_size, font_face, stoch_color_d1);
        ObjectSet("ObjLabel15", OBJPROP_CORNER, 0);
        ObjectSet("ObjLabel15", OBJPROP_XDISTANCE, 640);
        ObjectSet("ObjLabel15", OBJPROP_YDISTANCE, 3);        
               
      //stoch w1 value
      ObjectCreate("ObjLabel16", OBJ_LABEL, WindowFind("Digi Stoch"), 0, 0);
        ObjectSetText("ObjLabel16","W1: "+StringSubstr(stoch_w1_val,0,5),font_size, font_face, stoch_color_w1);
        ObjectSet("ObjLabel16", OBJPROP_CORNER, 0);
        ObjectSet("ObjLabel16", OBJPROP_XDISTANCE, 730);
        ObjectSet("ObjLabel16", OBJPROP_YDISTANCE, 3);        
               
      //stoch mn1 value
      ObjectCreate("ObjLabel17", OBJ_LABEL, WindowFind("Digi Stoch"), 0, 0);
        ObjectSetText("ObjLabel17","MN1: "+StringSubstr(stoch_mn1_val,0,5),font_size, font_face, stoch_color_mn1);
        ObjectSet("ObjLabel17", OBJPROP_CORNER, 0);
        ObjectSet("ObjLabel17", OBJPROP_XDISTANCE, 820);
        ObjectSet("ObjLabel17", OBJPROP_YDISTANCE, 3);        
                               
    }

//----
    return(0); 
//----
} 

//+------------------------------------------------------------------+